
class Player:
    def __init__(self, color, ai=False):
        self.color = color
        self.ai = ai  #artificial intelligence player... aka the computer
        self.regions = []
        self.regnames = []
        self.res = [0,0,0]
        self.cur_res = [1,0,0]
        self.res_gain = (0,0,0)
        

    def add_region(self, region):
        self.regions.append(region)
        self.regnames.append(region.id)

    def rem_region(self, region):
        if region in self.regions:
            self.regnames.remove(region.id)
            self.regions.remove(region)

    def calc_res(self):
        self.calc_gain()
        gold, metal, oil = self.res_gain
        self.res = [self.cur_res[0]+gold, self.cur_res[1]+metal, self.cur_res[2]+oil]
        self.cur_res = self.res[:]


    def calc_gain(self):
        gold, metal, oil = 0, 0, 0
        for reg in self.regions:
            gold += reg.res[0]
            metal += reg.res[1]
            oil += reg.res[2]
        self.res_gain = (gold, metal, oil)


