import pygame

class EventGroup(list):
    """Actually just a list that can be used to store events
    """
    def __init__(self):
        """initialises list
        """
        list.__init__(self)

    def add(self, event):
        """append event to list
        """
        self.append(event)

    def rem(self, event):
        """remove event from list
        returns True on success and False on fail
        """
        if event in self:
            self.remove(event)
            return True
        return False

    def empty(self):
        """clear list
        """
        self = []

class Event:
    """Basic Event class.

    """
    def __init__(self, type, dict, callback, arg=None):
        """Event constructor
        type: event type like KEYUP, MOUSEBUTTONDOWN, etc.
        dict: attribute of the event (see pygame.event.Event docs for more info)
        callback: function to be called when event is triggered
        arg: argument for callback (optional)
        """
        self.ev = pygame.event.Event(type, dict)
        self.callback = callback
        self.arg = arg

    def call(self):
        """call callback function
        """
        if self.arg is None:
            self.callback()
        else:
            self.callback(self.arg)
