from pykitten.data import *

RES = (800,600)
GFX = {}
SFX = {}
BGM = {}
FLAG = {}

HEX_img = {}
REGNAMES = []
MAP_img = {}

JB = JukeBox(["logo.ogg","bgm.ogg","gamewin.xm","gamelose.xm"])


def load_res():
    try:
        f = load("regnames.dat", "r")
        for line in f:
            REGNAMES.append(line.strip())
    except:
        print "Could not load regnames.dat."

    sfx = {}
    sfx["cancel"] = "cancel.ogg"
    sfx["confirm"] = "confirm.ogg"
    sfx["maphover"] = "hover02.ogg"
    sfx["mapclick"] = "click02.ogg"
    sfx["btnhover"] = "hover01.ogg"
    sfx["btnclick"] = "click01_2.ogg"
    sfx["sldclick"] = "tick01_2.ogg"
    sfx["blose"] = "battlelose.ogg"
    sfx["bwin"] = "battlewin.ogg"
    sfx["bdraw"] = "battledraw.ogg"


    for name in sfx:
        SFX[name] = load_sound(sfx[name])

    SFX["bwin"].set_volume(0.5)
    SFX["blose"].set_volume(0.5)
    SFX["bdraw"].set_volume(0.7)
    SFX["maphover"].set_volume(0.05)
    SFX["mapclick"].set_volume(0.2)
    SFX["btnclick"].set_volume(0.05)
    SFX["confirm"].set_volume(0.3)
    SFX["cancel"].set_volume(0.4)
    SFX["btnhover"].set_volume(0.1)
    SFX["sldclick"].set_volume(0.1)

    colorkey = (255,0,255)
    files = ["logo.png"]
    intfiles = [
        "moveslider.png",
        "youlose.png",
        "youwin.png",
        "plus.png",
        "pu.png",
        "build.png",
        "minus.png",
        "interface.png",
        "movement.png",
        "victory.png",
        "draw.png",
        "defeat.png",
        "battle.png",
        "general.png",
        "comm_fizzle2.png",
        "comm_fizzle1.png",
        "comm_red.png",
        "comm_blue.png",
        "comm_grey.png",
        "btn_build1.png",
        "btn_build2.png",
        "btn_build3.png",
        "btn_build4.png",
        "btn_move1.png",
        "btn_move2.png",
        "btn_move3.png",
        "btn_move4.png",
        "btn_cancel1.png",
        "btn_cancel2.png",
        "btn_cancel3.png",
        "btn_confirm1.png",
        "btn_confirm2.png",
        "btn_confirm3.png",
        "btn_save1.png",
        "btn_save2.png",
        "btn_save3.png",
        "btn_endturn1.png",
        "btn_endturn2.png",
        "btn_endturn3.png",
        "btn_exit1.png",
        "btn_exit2.png",
        "btn_exit3.png",
        "btn_load1.png",
        "btn_load2.png",
        "btn_load3.png",
        "btn_options1.png",
        "btn_options2.png",
        "btn_options3.png",
        "btn_plus.png",
        "btn_minus.png",
        "btn_plusplus.png",
        "btn_minusminus.png",
        "all.png",
        "report.png",
        ]

    gfx = load_gfx(files, colorkey)
    ints = load_gfx(intfiles, colorkey, folder="interface")

    for g in gfx.keys():
        GFX[g] = gfx[g]
    for g in ints.keys():
        GFX[g] = ints[g]

    startmenufiles = [
        "btn_main_back1.png",
        "btn_main_back2.png",
        "btn_main_back3.png",
        "btn_main_onepl1.png",
        "btn_main_onepl2.png",
        "btn_main_onepl3.png",
        "btn_main_quit1.png",
        "btn_main_quit2.png",
        "btn_main_quit3.png",
        "btn_main_restore1.png",
        "btn_main_restore2.png",
        "btn_main_restore3.png",
        "btn_main_start1.png",
        "btn_main_start2.png",
        "btn_main_start3.png",
        "btn_main_twopl1.png",
        "btn_main_twopl2.png",
        "btn_main_twopl3.png",
        "main.png",
        "credits.png",
        "choose.png",
    ]

    gfx = load_gfx(startmenufiles, colorkey, folder="startmenu")
    for g in gfx.keys():
        GFX[g] = gfx[g]

    flagfiles = [
        "flag_blue_m.png",
        "flag_blue_s.png",
        "flag_blue_t.png",
        "flag_red_m.png",
        "flag_red_s.png",
        "flag_red_t.png",
        "flag_grey_m.png",
        "flag_grey_s.png",
        "flag_grey_t.png",
        ]
    flag = load_gfx(flagfiles, (255,0,255), folder="flags")
    for name in flagfiles:
        FLAG[name[5:-4]] = flag[name]  #remove "flag_" and ".png" from name


    colorkey=(255,0,255)
    HEX_img["grey"] = load_image("hex_gn.png")
    HEX_img["greyh"] = load_image("hex_gh.png")
    HEX_img["red"] = load_image("hex_rn.png")
    HEX_img["redh"] = load_image("hex_rh.png")
    HEX_img["blue"] = load_image("hex_bn.png")
    HEX_img["blueh"] = load_image("hex_bh.png")
    HEX_img["unit"] = load_image("troop.png", colorkey)
    HEX_img["town"] = load_image("city.png", colorkey)
    HEX_img["hq"] = load_image("hq.png", colorkey)

    files = ["map01.png"]
    for f in files:
        map_img = load_gfx(files, colorkey, folder="maps")

    for i in map_img.keys():
        MAP_img[i] = map_img[i]

