import random

from unitdat import *


class Unit:
    def __init__(self, color, type):
        self.color = color
        self.type = type
        self.hp = unit_dat[type]["hp"]
        self.dam = unit_dat[type]["dam"]
        self.dam_mod = unit_dat[type]["dam_mod"]
        self.hit_mod = unit_dat[type]["hit_mod"]

        self.moved = False

    def attack(self, targets):
        type = targets[0].type
        type_index = TYPES.index(type)
        dam = random.randrange(1, self.dam) * self.dam_mod[type_index]
        nr = TYPES.index(type)
        hitmod = unit_dat[self.type]["hit_mod"][nr]
        for target in targets:
            hit = random.random() < hitmod
            if target.hp and hit:  #fire!
                target.hp -= dam  #todo: implement toHit modifier
                #print self.color + " " + self.type + " hits " + target.type + " for " + str(dam) + " damage.",
                if target.hp <= 0:
                    dam += target.hp  #rest of dam
                    target.hp = 0
                else:
                    dam = 0
                    print
                    break  #all dam distributed
        return dam

    def get_target(self, enemies, i=0):
        if len(TYPES) > i:
            for type in unit_dat[self.type]["target"][i:]:
                if enemies.has_key(type) and len(enemies[type]):
                    targets = enemies[type]
                    for target in targets:
                        if target.hp:
                            return targets
        return None



class Soldier(Unit):
    def __init__(self, color):
        Unit.__init__(self, color, "Soldier")

class Flamer(Unit):
    def __init__(self, color):
        Unit.__init__(self, color, "Flamethrower")

class Grenar(Unit):
    def __init__(self, color):
        Unit.__init__(self, color, "Grenadier")

class Tank(Unit):
    def __init__(self, color):
        Unit.__init__(self, color, "Tank")

class Jet(Unit):
    def __init__(self, color):
        Unit.__init__(self, color, "Jet")


UNIT_CLASSES = [Soldier, Flamer, Grenar, Tank, Jet]
UNIT_TYPES = {
    "Soldier": Soldier,
    "Flamethrower": Flamer,
    "Grenadier": Grenar,
    "Tank": Tank,
    "Jet": Jet,
}
