import pygame

from pykitten import utils
from pykitten.gui import ClickArea

from stuff import *
from menus import FadeState
from widgets import FONT


class WinLose(FadeState):
    def __init__(self, screen, win):
        pygame.mixer.music.set_volume(0.5)
        if win:
            img = GFX["youwin.png"]
            msg = ""
            JB.play("gamewin.xm")
        else:
            img = GFX["youlose.png"]
            msg = "Your HQ has been destroyed."
            JB.play("gamelose.xm")
        FadeState.__init__(self)
        self.screen.blit(screen, (0,0))
        x, y = utils.center(img.get_size(), (800,600))
        self.bg.blit(img, (x,y))

        img2 = FONT["small"].print_line(msg)
        pos = utils.center(img2.get_size(), (800,600))[0], \
            y + img.get_size()[1] - 20
        self.bg.blit(img2, pos)


    def after_fadein(self):
        clicky = ClickArea(pygame.Rect([0,0,800,600]),
            callback=self.to_menu)
        self.widgets.append(clicky)

    def to_menu(self):
        self.quit()

    def quit(self):
        pygame.mixer.music.fadeout(20)
        FadeState.quit(self)
